<template>
	<a-card :bordered="false">
		<a-form ref="searchFormRef" name="advanced_search" :model="searchFormState" class="ant-advanced-search-form mb-4">
			<a-row :gutter="24">
				<a-col :span="4">
					<a-form-item label="代码" name="futuresCode">
						<a-input v-model:value="searchFormState.futuresCode" placeholder="请输入代码"/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-form-item label="名称" name="futuresName">
						<a-input v-model:value="searchFormState.futuresName" placeholder="请输入名称"/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-form-item label="单位" name="futuresUnit">
						<a-input v-model:value="searchFormState.futuresUnit" placeholder="请输入单位"/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-form-item label="备注" name="remark">
						<a-input v-model:value="searchFormState.remark" placeholder="请输入备注"/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-button type="primary" @click="table.refresh(true)">查询</a-button>
					<a-button style="margin: 0 8px" @click="() => searchFormRef.resetFields()">重置</a-button>
				</a-col>
			</a-row>
		</a-form>
		<s-table
			ref="table"
			:columns="columns"
			:data="loadData"
			:alert="options.alert.show"
			bordered
			:row-key="(record) => record.id"
			:tool-config="toolConfig"
			:row-selection="options.rowSelection"
		>
			<template #operator class="table-operator">
				<a-space>
					<a-button type="primary" @click="formRef.onOpen()" v-if="hasPerm('depotZoneFuturesAdd')">
						<template #icon>
							<plus-outlined/>
						</template>
						新增
					</a-button>
					<a-button type="primary" @click="exportTable()"><export-outlined/>导出</a-button>
					<a-button danger @click="deleteBatchDepotZoneFutures()" v-if="hasPerm('depotZoneFuturesBatchDelete')">删除</a-button>
				</a-space>
			</template>
			<template #bodyCell="{ column, record }">
				<template v-if="column.dataIndex === 'action'">
					<a @click="detailFormRef.onOpen(record)" v-if="hasPerm('depotZoneFuturesEdit')">详情</a>
					<a @click="formRef.onOpen(record)" v-if="hasPerm('depotZoneFuturesEdit')">
						<a-divider type="vertical"/>
						编辑
					</a>
					<a-divider type="vertical" v-if="hasPerm(['depotZoneFuturesEdit', 'depotZoneFuturesDelete'], 'and')"/>
					<a-popconfirm title="确定要删除吗？" @confirm="deleteDepotZoneFutures(record)">
						<a-button type="link" danger size="small" v-if="hasPerm('depotZoneFuturesDelete')">删除</a-button>
					</a-popconfirm>
				</template>
			</template>
		</s-table>
	</a-card>
	<DetailForm ref="detailFormRef"/>
	<Form ref="formRef" @successful="table.refresh(true)"/>
</template>

<script setup name="depotZoneFutures">
import {message} from 'ant-design-vue'
import Form from './form.vue'
import depotZoneFuturesApi from '@/api/biz/depotZoneFuturesApi'
import DetailForm from './detailForm.vue'
import * as XLSX from "xlsx";
import moment from "moment";

let searchFormState = reactive({})
const searchFormRef = ref()
const table = ref()
const formRef = ref()
const detailFormRef = ref()
const toolConfig = {refresh: true, height: true, columnSetting: true, striped: false}
const columns = [
	{
		title: '代码',
		dataIndex: 'futuresCode'
	},
	{
		title: '名称',
		dataIndex: 'futuresName'
	},
	{
		title: '价格',
		dataIndex: 'futuresPrice'
	},
	{
		title: '单位',
		dataIndex: 'futuresUnit'
	},
	{
		title: '备注',
		dataIndex: 'remark'
	},
	{
		title: '更新时间',
		dataIndex: 'updateTime',
		width: '150px'
	},
]
// 操作栏通过权限判断是否显示
columns.push({
	title: '操作',
	dataIndex: 'action',
	align: 'center',
	width: '150px'
})
let selectedRowKeys = ref([])
// 列表选择配置
const options = {
	alert: {
		show: false,
		clear: () => {
			selectedRowKeys = ref([])
		}
	},
	rowSelection: {
		onChange: (selectedRowKey, selectedRows) => {
			selectedRowKeys.value = selectedRowKey
		}
	}
}
let loadDataLst
const loadData = (parameter) => {
	const searchFormParam = JSON.parse(JSON.stringify(searchFormState))
	return depotZoneFuturesApi.depotZoneFuturesPage(Object.assign(parameter, searchFormParam)).then((data) => {
		loadDataLst = data.records
		return data
	})
}
// 删除
const deleteDepotZoneFutures = (record) => {
	let params = [
		{
			id: record.id
		}
	]
	depotZoneFuturesApi.depotZoneFuturesDelete(params).then(() => {
		table.value.refresh(true)
	})
}
// 批量删除
const deleteBatchDepotZoneFutures = () => {
	if (selectedRowKeys.value.length < 1) {
		message.warning('请选择一条或多条数据')
		return false
	}
	const params = selectedRowKeys.value.map((m) => {
		return {
			id: m
		}
	})
	depotZoneFuturesApi.depotZoneFuturesDelete(params).then(() => {
		table.value.clearRefreshSelected()
	})
}
// 导出
const exportTable = () => {
	let tableData = [['代码', '名称',  '价格', '单位', '备注', '更新时间']]
	let idStr = ''
	if (selectedRowKeys.value.length > 0) {
		selectedRowKeys.value.map((m) => {
			idStr = idStr + ',' + m
		})
	}
	loadDataLst.map((m) => {
		if (!idStr || idStr.indexOf(m.id) > 0)
			tableData.push([m.futuresCode, m.futuresName, m.futuresPrice, m.futuresUnit, m.remark, m.updateTime])
	})
	let workSheet = XLSX.utils.aoa_to_sheet(tableData)
	let bookNew = XLSX.utils.book_new()
	XLSX.utils.book_append_sheet(bookNew, workSheet, 'Sheet1')
	let name = '期货信息' + moment().format('_YYYY-MM-DD') + '.xlsx'
	XLSX.writeFile(bookNew, name)
}
</script>
